/**********
This library is free software; you can redistribute it and/or modify it under
the terms of the GNU Lesser General Public License as published by the
Free Software Foundation; either version 2.1 of the License, or (at your
option) any later version. (See <http://www.gnu.org/copyleft/lesser.html>.)

This library is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
more details.

You should have received a copy of the GNU Lesser General Public License
along with this library; if not, write to the Free Software Foundation, Inc.,
59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**********/
// "liveMedia"
// Author Flavio Oliveira
// AAC Parser
// C++ header

#ifndef _AACINTERNALS_H_
#define _AACINTERNALS_H_

#ifndef _BOOLEAN_HH
#include "Boolean.hh"
#endif

typedef struct {
    short protection_absent ;
    short sample_frequency_index;
    short aac_frame_length;
    short adts_buffer_fullness;
    short number_of_raw_data_blocks_in_frame;
    short header_size ; 
} hdr;

class AACFrame
{
public:
	AACFrame();
	~AACFrame();

	Boolean findADTSHeader(const unsigned char *data, int nbytes, int &nBytesRead, hdr *pHdr);
	Boolean isADIFHeader(const unsigned char *data, int nbytes, int &nBytesRead);
	
private:
   
	void setup(const unsigned char *input, int nbytes);
	void putBits();
	unsigned int readBits(unsigned int nBits) ;
	unsigned int peekBits(unsigned int nBits) ;
	void skipBits(unsigned int nBits) {fTotNumBits <<= nBits; fCurBitIndex -= nBits;}
	int isOutOfBits();
	int nBitsRead() const;	
	
private:

    const unsigned char *fStartBytePtr;
    const unsigned char *fBaseBytePtr;
    const unsigned char *fEndBytePtr;
    unsigned int fTotNumBits;
    int fCurBitIndex;
};

#endif /* _AACINTERNALS_H_ */
